#define _TI_ENHANCED_MATH_H 1
#include <math.h>

#include "fft.h"
#include "blocks.h"

/* MODIFICATION STARTS HERE */

//#define ADDNOISE 5

#define AVERAGING 1

#define NORM (1.0/AVERAGING)

/*   global variables */
fft16Params fft16; // fft parameters  
float welch[FFTSZ];// Welch Periodogram
short window[FFTSZ]; //Hamming window coefficients

int counter = -15;
extern int stop_flag;

void init( void)
{
    int i=0;
    fft_init( &fft16, FFTSZ);
    for(i=0;i<FFTSZ;i++)
    	welch[i]=0.0;
    hamming_window( window, FFTSZ);	
    	
}


void processing( void *ptr )
{
  int i=0,mean=0;
  short *sigbuf = ptr;
  short *fftbuf;
  float a=0,b=0;
  float tmp=0.0;
  
  #ifdef ADDNOISE
  	short rndnum=0;
//  	srand(counter);
  #endif	  		 
  
  counter ++;
  
  if (counter == 0)
   	for(i=0;i<FFTSZ;i++)
	{
		welch[i] = 0.0;
	}

  if (counter > 0 && counter <= AVERAGING)
  {
  fftbuf=(short*)malloc(2*FFTSZ*DATSZ);
  if (fftbuf )
  {
  	for(i=0; i<fft16.fft_size; i++)
  	{
  		 #ifdef ADDNOISE
  		   	rndnum=(short)(rand() >> ADDNOISE);
  		   	fftbuf[2*i]=sigbuf[i]+rndnum;
  		 #else
  		 	fftbuf[2*i]=sigbuf[i];
  		 #endif	  		 
  	   	 mean+=(int)fftbuf[2*i];
  	   	 fftbuf[2*i+1]=0;
    }
    mean >>= fft16.log_dual_sz;
   	for(i=0; i<fft16.fft_size; i++)
  		 fftbuf[2*i]= (short)(( ((int)fftbuf[2*i]-mean)*(int)window[i] ) >> 15);
  	
  	fft(&fft16,fftbuf);
  	for(i=0;i<FFTSZ;i++)
  	{
  		a=(float)fftbuf[2*i];
  		b=(float)fftbuf[2*i+1];
  		//a=a*a;
  		//b=b*b;
  		//a=a+b;
  		tmp=(a*a+b*b)*(1.0/12996.0);  // hamming window normalization

  	 	welch[i]=(welch[i]+tmp*NORM);



  	}
  	free(fftbuf);
  }
  }// if counter>0 and counter < AVERAGING
  else if (counter > 0)
  {
  	counter = -15;
  	stop_flag = 1;


  }
}
